
#include "defextern.h"
#include "main.h"
#include "asciimovie.h"
#include "asciiframe.h"
#include "editproc.h"
#include "file.h"

ULONG nownum;
ULONG nummax=0;
ULONG maxlength=0;
int mode;
char endmark[]="[end]";
char buffernow[buffermax+1];
char lineend[]="\x0d\x0a";

void setmode(int m)
{
	mode =m;
}

ULONG getframenum()
{
	return nownum;
}

void framenumreset()
{
	nownum=0;
}

void framenumplus(long n)
{
	n=n+nownum;
	nownum =max(0,n);
	nummax =max(nownum,nummax);
}

void saveframe(char *name)
{
	char *buffer=buffernow;
	wsprintf(buffer,"%s%04d.txt",name,nownum);
	ofstream ou(buffer,ios::binary);
	GetWindowText(hwndEdit,buffer,buffermax);
	ou.write(buffer,strlen(buffer));
}
ULONG searchmax(char *name , char *buffer)
{
	int num=0;
	ULONG max=0;
	while(num<nummax)
	{
		wsprintf(buffer,"%s%04d.txt",name,num);
		ifstream in(buffer,ios::binary | ios::nocreate);
		if(in)
		{
			in.read(buffer,buffermax);
			max=max(max,in.gcount());
		}
		num++;
	}
	return max;
}

ULONG searchnummax(char *name , char *buffer)
{
	ULONG num=10000;
	return num;
}
void saveallframe(char *name)
{
	ULONG num=0;
	char *buffer=buffernow;
	wsprintf(buffer,"%s.txt",name);
	ofstream ou(buffer,ios::binary);
	nummax=searchnummax(name,buffer);
	//maxlength =searchmax(name,buffer);
	maxlength=buffermax;
	memset(buffer,0,buffermax);
	//wsprintf(buffer,"%d",maxlength);
	//ou.write(buffer,strlen(buffer));
	//ou.write(lineend,2);
	while(num<nummax)
	{
		wsprintf(buffer,"%s%04d.txt",name,num);
		ifstream in(buffer,ios::binary | ios::nocreate);
		memset(buffer,0,buffermax);
		if(in)
		{
			wsprintf(buffer,"%04d",num);
			ou.write(buffer,strlen(buffer));
			ou.write(lineend,2);
			memset(buffer,0,buffermax);
			in.read(buffer,maxlength);
			ou.write(buffer,strlen(buffer));
			ou.write(lineend,2);
			ou.write(endmark,strlen(endmark));
			ou.write(lineend,2);
		}
		num++;
	}
}

void loadframe(char *name)
{
	char *buffer=buffernow;
	memset(buffer,0,buffermax);
	if(mode==MODE_MAKING)
	{
		wsprintf(buffer,"%s%04d.txt",name,nownum);
		ifstream in(buffer,ios::binary | ios::nocreate);
		memset(buffer,0,buffermax);
		in.read(buffer,buffermax);
		buffer[strlen(buffer)]='\0';
	}
	if(mode==MODE_ALL)
	{
		int num=0;
		char dummy[10];
		wsprintf(buffer,"%s.txt",name);
		ifstream in(buffer,ios::binary | ios::nocreate);
		memset(buffer,0,buffermax);
		//in.get(buffer,10,lineend[0]);
		//in.seekg(strlen(lineend),ios::cur);
		//sscanf(buffer,"%d",&maxlength);
		maxlength=buffermax;
		while(in && num<=nownum)
		{
			int n;
			char *p;
			in.get(buffer,10,lineend[0]);
			if(in.gcount()==0)
			{
				playing=FALSE;
				break;
			}
			sscanf(buffer,"%d",&num);
			in.seekg(strlen(lineend),ios::cur);
			memset(buffer,0,buffermax);
			in.read(buffer,maxlength);
			if(in.gcount()==0) 
			{
				playing=FALSE;
				break;
			}
			p=strstr(buffer,endmark);
			if(p!=NULL) *p='\0';
			if(num==nownum) break;
			if(num>nownum)
			{
				buffer[0]='\0';
				break;
			}
			if(in.eof()) in.clear();
			in.seekg(strlen(buffer)-in.gcount()+strlen(endmark)+strlen(lineend),ios::cur);
			//num++;
		}
	}
	SetWindowText(hwndEdit,buffer);
	wsprintf(buffer,"%ld",getframenum());
	SetDlgItemText(hwndMain,IDC_EDIT1,buffer);
}



//---------------------------------------------------
// I[in@t@C@R}t@CɓWJB
// t@Cɂ̓R}ԂB

void filetoframe(char *name)
{
	int num=0;
	char dummy[10];
	char outfile[MAX_PATH];
	char *buffer=buffernow;
	ofstream ou;
	wsprintf(buffer,"%s.txt",name);
	ifstream in(buffer,ios::binary | ios::nocreate);
	memset(buffer,0,buffermax);
	maxlength=buffermax;
	while(in)
	{
		int n;
		char *p;
		in.get(buffer,10,lineend[0]);
		if(in.gcount()==0)
		{
			break;
		}
		sscanf(buffer,"%d",&num);
		in.seekg(strlen(lineend),ios::cur);
		memset(buffer,0,buffermax);
		in.read(buffer,maxlength);
		if(in.gcount()==0) 
		{
			break;
		}
		p=strstr(buffer,endmark);
		if(p!=NULL) *p='\0';
		if(in.eof()) in.clear();
		in.seekg(strlen(buffer)-in.gcount()+strlen(endmark)+strlen(lineend),ios::cur);
		if(strlen(buffer)>0)
		{
			wsprintf(outfile,"%s%04d.txt",name,num);
			ou.open(outfile,ios::binary);
			ou.write(buffer,strlen(buffer));
			ou.close();
		}
	}
}

void copytonext(char *name)
{
	char buffer[MAX_PATH];
	wsprintf(buffer,"%s%04d.txt",name,nownum);
	ifstream in(buffer,ios::binary | ios::nocreate);
	if(!in) return;
	wsprintf(buffer,"%s%04d.txt",name,nownum+1);
	ofstream ou(buffer,ios::binary);
	copyfile(in,ou);
}